project/models.py
from project import db


# Flask and Flask-SQLAlchemy initialization here


class User(db.Model):
    """
    User table
    """
    __tablename__ = 'user'
    id = db.Column(db.Integer, primary_key=True)
    username = db.Column(db.String(80), unique=True, nullable=False)
    email = db.Column(db.String(120), unique=True)
    password = db.Column(db.String(255))

    def __init__(self, username="", email="", password=""):
        self.username = username
        self.email = email
        self.password = password

    def is_active(self):
        return True

    def is_authenticated(self):
        return True

    def get_id(self):
        return self.id

    def __repr__(self):
        return '<User %r>' % self.username


class Recognition(db.Model):
    """
    Recognition table
    """
    __tablename__ = 'recognition'
    id = db.Column(db.Integer, primary_key=True)
    username = db.Column(db.String(80), nullable=True)
    timestamp = db.Column(db.String(80), nullable=True)
    flag = db.Column(db.String(10), nullable=True)


class WhiteList(db.Model):
    """
    White list and Black list
    """
    __tablename__ = "peoplelist"
    id = db.Column(db.Integer, primary_key=True)
    username = db.Column(db.String(80), nullable=True)
    timestamp = db.Column(db.DateTime, nullable=True)
    block = db.Column(db.Boolean, nullable=True)


class RecordList(db.Model):
    """
    The records for storing the action of unknown person.
    """
    __tablename__ = "recordlist"
    id = db.Column(db.Integer, primary_key=True)
    phonenumber = db.Column(db.String(80), nullable=True)
    timestamp = db.Column(db.DateTime, nullable=True)

project/forms.py
from flask_wtf import Form
from math import ceil
from wtforms import StringField, PasswordField, validators
from wtforms.validators import DataRequired, Email, Length, EqualTo


class RegisterForm(Form):
    """
    Register Form
    """
    username = StringField(label="username", validators=[validators.Length(min=4, max=25)])
    email = StringField(label="E-mail", validators=[validators.Length(min=4, max=25)])
    password = PasswordField(label='Password', validators=[
        DataRequired()
    ])


class LoginForm(Form):
    """
    Login Form
    """
    email = StringField(label="E-mail", validators=[validators.Length(min=4, max=25)])
    password = PasswordField(label='Password', validators=[
        DataRequired()
    ])


class Pagination(object):

    def __init__(self, page, per_page, total_count):
        self.page = page
        self.per_page = per_page
        self.total_count = total_count

    @property
    def pages(self):
        return int(ceil(self.total_count / float(self.per_page)))

    @property
    def has_prev(self):
        return self.page > 1

    @property
    def has_next(self):
        return self.page < self.pages

    def iter_pages(self, left_edge=2, left_current=2,
                   right_current=5, right_edge=2):
        last = 0
        for num in range(1, self.pages + 1):
            if num <= left_edge or \
                    (num > self.page - left_current - 1 and num < self.page + right_current) \
                    or num > self.pages - right_edge:
                if last + 1 != num:
                    yield None
                yield num
                last = num

project/__init__.py
from flask import Flask
from flask_login import LoginManager
from flask_sqlalchemy import SQLAlchemy
from flask_bcrypt import Bcrypt
from flask_admin import Admin
from flask_admin.contrib.sqla import ModelView
import os
app = Flask(__name__)

cur_path = os.path.dirname(os.path.abspath(__file__))
par_path = os.path.join(cur_path, os.pardir)

login_manager = LoginManager()
login_manager.init_app(app)

db = SQLAlchemy(app)
bcrypt = Bcrypt(app)

app.config['SQLALCHEMY_DATABASE_URI'] = 'sqlite:///' + par_path + '/needle.sqlite3'
app.config['SECRET_KEY'] = "1254sd15gfrf1edewg1er5fefe_ed"
app.config['FLASK_ADMIN_SWATCH'] = 'cerulean'
app.config['DEBUG'] = False

admin = Admin(app, name='Needle Solution', template_mode='bootstrap3')

from project.views import main_blueprint

app.register_blueprint(main_blueprint)

from project.models import User, WhiteList, Recognition


@login_manager.user_loader
def load_user(user_id):
    return User.query.filter(User.id == int(user_id)).first()


admin.add_view(ModelView(User, db.session))
admin.add_view(ModelView(WhiteList, db.session))
admin.add_view(ModelView(Recognition, db.session))

project/views.py
from flask import render_template, Response, request, redirect, url_for, Blueprint, flash
from flask_login import login_required, login_user, logout_user
from project.forms import RegisterForm, LoginForm
from project import db, bcrypt, login_manager
from project.models import User, Recognition, RecordList
from project.utils.odroid_face_recognition import *
from project.utils.rfid_reader import *
import smtplib
from email.mime.multipart import MIMEMultipart
from email.mime.text import MIMEText


cur_path = os.path.dirname(os.path.abspath(__file__))
data_path = os.path.join(cur_path, "dataset")
basic_credentials = ("ptkalerts@needlesolutions.com", "Kus54394")

NoneType = type(None)
main_blueprint = Blueprint('main', __name__, )


@main_blueprint.route('/')
@login_required
def index():
    """
    Returns 'index.html' page in route '/'
    :return:
    """
    return render_template('index.html')


@main_blueprint.route('/register', methods=['GET', 'POST'])
def register():
    """
    Returns 'register.html' page in route '/register'
    Redirects 'login.html' page after stored new username and password when request method is post.
    :return:
    """
    register_form = RegisterForm(request.form)
    if request.method == 'POST' and register_form.validate_on_submit():
        user = User(register_form.username.data, register_form.email.data,
                    bcrypt.generate_password_hash(register_form.password.data).decode('utf - 8'))
        db.session.add(user)
        db.session.commit()

        return redirect(url_for('main.login'))
    return render_template('register.html', form1=register_form)


@main_blueprint.route('/login', methods=['GET', 'POST'])
def login():
    """
    Returns 'login.html' page in route '/login'.
    Redirects the 'index.html' page or next url when login is successful.
    :return:
    """
    login_form = LoginForm(request.form)
    if request.method == 'POST' and login_form.validate():
        user = User.query.filter_by(email=login_form.email.data).first()
        if user and bcrypt.check_password_hash(user.password, login_form.password.data):
            login_user(user)
            next = request.args.get('next')
            return redirect(next or url_for('main.index'))

        else:
            flash('Invalid email and/or password.', 'danger')
            return render_template('login.html', login_form=login_form)

    return render_template('login.html', login_form=login_form)


@main_blueprint.route('/api/recv_number')
@login_required
def recv_phone_number():
    """
    Receive the phone number
    :return:
    """
    pass


@main_blueprint.route('/api/check_recognized')
@login_required
def check_recognized():
    """
    Simultaneously checking the person recognized
    :return:
    """

    json_data = []
    recognized_person = Recognition.query.filter_by(flag="False").all()
    previous_name = None
    if len(recognized_person):
        for item in recognized_person:
            if previous_name == item.username:
                continue
            json_data.append({
                "name": item.username,
                "timestamp": item.timestamp,
                "img_path": "/static/dataset/" + item.username + "/1.jpg"
            })
            item.flag = "True"
            db.session.commit()
            previous_name = item.username
        dumped_data = json.dumps({"content": json_data})
        return dumped_data
    else:
        dumped_data = json.dumps({"content": None})
        return dumped_data


@main_blueprint.route('/logout')
@login_required
def logout():
    """
    Returns 'login.html' page after user is logged out.
    :return:
    """
    logout_user()
    flash('You were logged out.', 'success')
    return redirect(url_for('main.login'))


def send_alert_email():
    """
    Send the alert in the email.
    :return:
    """
    SERVER = "smtp.office365.com"
    MY_ADDRESS = "ptkalerts@needlesolutions.com"
    PASSWORD = "Kus54394Kus54394"
    TO = ["ptkalertsgroup@needlesolutions.com"]
    # "catkinson@needlesolutions.com",
    SUBJECT = "Testing an alert for needle."
    TEXT = "Testing an alert for needle."

    # Prepare actual message
    message = """From: %s\r\nTo: %s\r\nSubject: %s\r\n\%s""" % (MY_ADDRESS, ", ".join(TO), SUBJECT, TEXT)

    server = smtplib.SMTP(SERVER, port=587)
    server.starttls()
    server.login(MY_ADDRESS, PASSWORD)

    msg = MIMEMultipart()  # create a message

    # setup the parameters of the message
    msg['From'] = MY_ADDRESS
    msg['To'] = "ptkalertsgroup@needlesolutions.com"
    msg['Subject'] = "This is testing to send an alert."

    # add in the message body
    msg.attach(MIMEText(message, 'plain'))

    # send the message via the server set up earlier.
    server.send_message(msg)
    server.quit()


def gen():
    """
    Start the thread to receive the streaming data from socket server and returns the image processed.
    :return:
    """
    while True:
        frame = recognition.proc_streaming_marked()
        if frame is not None:
            yield (b'--frame\r\n'
                   b'Content-Type: image/jpeg\r\n\r\n' + frame + b'\r\n\r\n')


@main_blueprint.route('/video_feed')
@login_required
def video_feed():
    """
    Returns the image data as bytes.
    :return:
    """
    return Response(gen(),
                    mimetype='multipart/x-mixed-replace; boundary=frame')


@main_blueprint.route('/register_people', methods=['GET', 'POST'])
@login_required
def register_people():
    """
    Returns the image data as bytes.
    :return:
    """
    return render_template('register_people.html')


@main_blueprint.route("/events_list", methods=["GET", "POST"])
@login_required
def read_rfid():
    """
    Read rfid tag.
    :return:
    """
    events_all = Recognition.query.all()
    return render_template('events_list.html', events=events_all)


@main_blueprint.route("/write_rfid", methods=["GET", "POST"])
@login_required
def write_rfid():
    """
    Write data to rfid tag.
    :return:
    """
    pass


@login_manager.unauthorized_handler
def unauthorized_callback():
    """
    Redirects the login page when user is unauthorized.
    :return:
    """
    return redirect('/login?next=' + request.path)

project/templates/base.html
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="utf-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <meta name="description" content="">
    <meta name="author" content="">

    <title>Needle Solution v1.0</title>

    <link href="/static/vendor/bootstrap/css/bootstrap.min.css" rel="stylesheet">
    <link href="/static/vendor/metisMenu/metisMenu.min.css" rel="stylesheet">
    <link href="/static/dist/css/sb-admin-2.css" rel="stylesheet">
    <link href="/static/vendor/morrisjs/morris.css" rel="stylesheet">
    <link href="/static/vendor/font-awesome/css/font-awesome.min.css" rel="stylesheet" type="text/css">
    <link href="https://vjs.zencdn.net/7.0/video-js.min.css" rel="stylesheet">
    <script src="https://vjs.zencdn.net/7.0/video.min.js"></script>
</head>

<body>

    <div id="wrapper">

        <!-- Navigation -->
        <nav class="navbar navbar-default navbar-static-top" role="navigation" style="margin-left: 10px;margin-bottom: 0">
            <div class="navbar-header">
                <button type="button" class="navbar-toggle" data-toggle="collapse" data-target=".navbar-collapse">
                    <span class="sr-only">Toggle navigation</span>
                    <span class="icon-bar"></span>
                    <span class="icon-bar"></span>
                    <span class="icon-bar"></span>
                </button>
                <a class="navbar-brand" href="/">Needle Solution</a>
            </div>
            <!-- /.navbar-header -->

            <ul class="nav navbar-top-links navbar-right">
                <li><a href="/logout"><i class="fa fa-sign-out fa-fw"></i> Logout</a>
                </li>

            </ul>
            <!-- /.navbar-top-links -->

            <div class="navbar-default sidebar" role="navigation">
                <div class="sidebar-nav navbar-collapse">
                    <ul class="nav" id="side-menu">
                        <li class="sidebar-search">
                            <div class="input-group custom-search-form">
                                <input type="text" class="form-control" placeholder="Search...">
                                <span class="input-group-btn">
                                <button class="btn btn-default" type="button">
                                    <i class="fa fa-search"></i>
                                </button>
                            </span>
                            </div>
                        </li>
                        <li>
                            <a href="/"><i class="fa fa-dashboard fa-fw"></i> Dashboard</a>
                        </li>
                        <li>
                            <a href="/register_people"><i class="fa fa-edit fa-fw"></i> Register People</a>
                        </li>
                        <li>
                            <a href="/events_list"><i class="fa fa-play fa-fw"></i> Events</a>
                        </li>
                        <li>
                            <a href="/admin"><i class="fa fa-adjust fa-fw"></i> Admin Page</a>
                        </li>
                    </ul>
                </div>
            </div>
        </nav>

        <div id="page-wrapper">
            <div class="row">
                <div class="col-lg-12">
                    <h1 class="page-header" style="margin-left: 20px">Needle Solution</h1>
                    <div class="row">
                        {% block content %}
                        {% endblock %}
                    </div>
                </div>
            </div>
        </div>

        {% include 'footer.html' %}

    </div>
    <script src="/static/vendor/jquery/jquery.min.js"></script>
    <script src="/static/vendor/bootstrap/js/bootstrap.min.js"></script>
    <script src="/static/vendor/metisMenu/metisMenu.min.js"></script>
    <script src="/static/dist/js/sb-admin-2.js"></script>
    {%block script%}
    {%endblock%}
</body>

</html>

project/templates/events_list.html
{% extends "base.html" %}
{%block content %}
<div class="container">
    <div class="col-lg-6 table-responsive">
        <table class="table">
            <thead>
            <tr>
                <th> Name</th>
                <th> Detected Timestamp</th>
            </tr>
            </thead>
            <tbody>

            {% for event in events %}
            <tr id={{ event.id }}>
                <td> {{event.username }}</td>
                <td> {{ event.timestamp }}</td>
            </tr>
            {% endfor %}

            </tbody>
        </table>
    </div>
</div>
{%endblock%}

project/templates/footer.html
<!-- Begin Footer -->
<footer class="footer">
    <div class="container">
    <!-- Copyright -->
    <div class="row">
        <hr>
        <div class="col-sm-11 col-xs-10">
            <p class="copyright">© 2019 All rights reserved.</p>
        </div>
        <div class="col-sm-1 col-xs-2 text-right">
            <a href="#" class="scroll-top">
                <div class="footer-scrolltop-holder"><span class="ion-ios7-arrow-up footer-scrolltop"></span>
                </div>
            </a>
        </div>
    </div>
</div>
</footer>

project/templates/index.html
{% extends "base.html" %}
{%block content %}
<div class="container">
    <div class="col-lg-8">
        <img id="bg" src="{{ url_for('main.video_feed') }}" width="100%" height="120%">
    </div>
    <div class="col-lg-2">
        <label class="title" style="color: #017ebc">Detected People List</label>

        <div class="form-group">
            <textarea rows="10" cols="20" id="detected_box">
            </textarea>
        </div>
        <div class="form-group">
            <button id="visitButton" type="button" class="btn btn-info btn-lg"  style="display: none;">I have visited here before</button>
        </div>
        <div class="form-group" id="phoneNumber" style="display: none;">
            <label class="title" style="color: #017ebc">Enter phone number</label>
            <input type="number" id="input_phoneNumber"/>
            <button type="button" class="btn btn-success btn-block" id="button_phoneNumber">Submit</button>
        </div>
    </div>
    <div class="col-lg-2">
        <div class="form-group">
            <img id="portrait" width="50%" height="60%">
        </div>
    </div>
</div>
{%endblock%}
{%block script%}
<script>

    $("#visitButton").click(function () {
        $("#phoneNumber").show();
        $("#visitButton").hide();
    });
    $("#button_phoneNumber").click(function () {
        var input_phoneNumber = $('#input_phoneNumber').val();
        $("#phoneNumber").hide();
        $("#visitButton").hide();

        sendPhoneNumber(input_phoneNumber);
    });

    function sendPhoneNumber(phone_number){
        console.log(phone_number);
        //Implementing /api/recv_number
    }
    function getRecognized() {
        $.getJSON("/api/check_recognized", function (data) {
            var json_data = data;
            var img_path = "";
            var msg = "";
            if (json_data.content !== null) {
                for (var i = 0; i < json_data.content.length; i++) {
                    msg += json_data.content[i].name + "  at " + json_data.content[i].timestamp + ".\n\n";
                    if (json_data.content[i].name.includes("Unknown")) {
                        msg = "Unrecognized guest \n\n" +
                            "- please login at the kiosk below";
                        img_path = "/static/unknown.png";
                        $("#visitButton").show();
                    }
                    else
                        img_path = json_data.content[i].img_path;

                }
                document.getElementById("detected_box").value = msg;
                document.getElementById("portrait").src = img_path;
            }
        })
    }

    setInterval(getRecognized, 1000)
</script>
{%endblock%}

project/templates/login.html
<!DOCTYPE html>
<html lang="en">

<head>

    <meta charset="utf-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <meta name="description" content="This is Demo System for object detection">
    <meta name="author" content="Evander Jones">
    <title>Needle Solution v1.0</title>

    <link href="/static/vendor/bootstrap/css/bootstrap.min.css" rel="stylesheet">
    <link href="/static/vendor/metisMenu/metisMenu.min.css" rel="stylesheet">
    <link href="/static/dist/css/sb-admin-2.css" rel="stylesheet">
    <link href="/static/vendor/font-awesome/css/font-awesome.min.css" rel="stylesheet" type="text/css">

</head>

<body>

    <div class="container">
        <div class="row">
            <div class="col-md-4 col-md-offset-4">
                <div class="login-panel panel panel-default">
                    <div class="panel-heading">
                        <h3 class="panel-title">Please Sign In</h3>
                    </div>
                    <div class="panel-body">
                        <form role="form" method="POST">
                            {{ login_form.csrf_token }}
                            <fieldset>
                                <div class="form-group">
                                    {{ login_form.email(class="form-control", placeholder="E-mail", class_='required') }}
                                </div>
                                <div class="form-group">
                                    {{ login_form.password(class="form-control", placeholder="Password", class_='required') }}
                                </div>
                                <!-- Change this to a button or input when using this as a form -->
                                <button type="submit" href="/" class="btn btn-lg btn-success btn-block">Login</button>
                            </fieldset>
                        </form>
                        <br/>
                        <br/>
                        <a href="/register" class="btn btn-lg btn-default btn-block">Register</a>
                    </div>
                </div>
            </div>
        </div>
    </div>
    <script src="/static/vendor/jquery/jquery.min.js"></script>
    <script src="/static/vendor/bootstrap/js/bootstrap.min.js"></script>
    <script src="/static/vendor/metisMenu/metisMenu.min.js"></script>
    <script src="/static/dist/js/sb-admin-2.js"></script>
</body>

</html>

project/templates/register.html
<!DOCTYPE html>
<html lang="en">

<head>

    <meta charset="utf-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <meta name="description" content="This is Demo System for object detection">
    <meta name="author" content="Evander Jones">
    <title>Needle Solution v1.0</title>

    <link href="/static/vendor/bootstrap/css/bootstrap.min.css" rel="stylesheet">
    <link href="/static/vendor/metisMenu/metisMenu.min.css" rel="stylesheet">
    <link href="/static/dist/css/sb-admin-2.css" rel="stylesheet">
    <link href="/static/vendor/font-awesome/css/font-awesome.min.css" rel="stylesheet" type="text/css">

</head>

<body>

    <div class="container">
        <div class="row">
            <div class="col-md-4 col-md-offset-4">
                <div class="login-panel panel panel-default">
                    <div class="panel-heading">
                        <h3 class="panel-title">Please Register</h3>
                    </div>
                    <div class="panel-body">
                        <form role="form" method="POST">
                            {{ form1.csrf_token }}
                            <fieldset>
                                <div class="form-group">
                                    {{ form1.username(class="form-control", placeholder="Username", class_='required') }}
                                </div>
                                <div class="form-group">
                                    {{ form1.email(class="form-control", placeholder="E-mail", class_='required') }}
                                </div>
                                <div class="form-group">
                                    {{ form1.password(class="form-control", placeholder="Password", class_='required') }}
                                </div>
                                <!-- Change this to a button or input when using this as a form -->
                                <button type="submit" class="btn btn-lg btn-success btn-block">Register</button>
                            </fieldset>
                        </form>
                    </div>
                </div>
            </div>
        </div>
    </div>
    <script src="/static/vendor/jquery/jquery.min.js"></script>
    <script src="/static/vendor/bootstrap/js/bootstrap.min.js"></script>
    <script src="/static/vendor/metisMenu/metisMenu.min.js"></script>
    <script src="/static/dist/js/sb-admin-2.js"></script>
</body>

</html>

project/templates/register_people.html
{% extends "base.html" %}
{%block content %}
<div class="container">
    <div class="col-lg-4">
        <form method=post enctype=multipart/form-data>
            <div class="form-group">
                <label>Upload *.zip file with the name registering.</label>
                <input type="file">
            </div>
        </form>
    </div>
</div>
{%endblock%}
{%block script%}
{%endblock%}